#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <wininet.h>

#include "resource.h"
#include "exports.h"
#include "lsapi.h"

BOOL CheckForMark();
BOOL Register();
BOOL SetMark();

HANDLE thread=NULL;
DWORD threadID=0;
HWND hwndMain=NULL, hwndDlg;
HWND status=NULL, exitbtn=NULL;

int ScreenX, ScreenY;

int X, Y, W, H;
COLORREF FontColor;
HFONT Font;
char PreText[256] = "";
BOOL AOT=FALSE;
int ID=-1;

BOOL CALLBACK DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath)
{
	char temp[256] = "";
	int size;
	WNDCLASS wc;

	memset(&wc,0,sizeof(wc));
    wc.lpfnWndProc = WndProc;
    wc.hInstance = dll;
	wc.lpszClassName = "LSCount";
	RegisterClass(&wc);
	
	ID = CheckForMark();
	
	if (ID == -1)
	{
		if (MessageBox(parent, "Thank you for helping us try and get an accurate count of how many LiteSTEP users there are.  This module does not relay any information about you or your computer.  It simply connects and then disconnects.\n\nClick 'Yes' to continue.\nClick 'No' to cancel.", "LSCount", MB_SYSTEMMODAL | MB_YESNO | MB_ICONWARNING) == IDYES)
		{
			hwndDlg = CreateDialog(dll, MAKEINTRESOURCE(IDD_STATUS), parent, DlgProc);
			status = GetDlgItem(hwndDlg, IDC_STATUS);
			exitbtn = GetDlgItem(hwndDlg, IDC_EXIT);
			thread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)Register, (LPVOID)NULL, 0, &threadID);
		}
	}
	
	ScreenX = GetSystemMetrics(SM_CXSCREEN);
	ScreenY = GetSystemMetrics(SM_CYSCREEN);

	X = GetRCInt("LSCountX", 0);
	Y = GetRCInt("LSCountY", 0);
	W = GetRCInt("LSCountW", 100);
	H = GetRCInt("LSCountH", 24);
	FontColor = GetRCColor("LSCountFontColor", 0x00000000);
	GetRCString("LSCountPreText", PreText, "LS User: ", 256);
	GetRCString("LSCountFontFace", temp, "Arial", 256);
	size = GetRCInt("LSCountFontSize", 16);
	Font = CreateFont(size, 0, 0, 0, FW_DONTCARE, FALSE, FALSE, FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, temp);
	AOT = GetRCBool("LSCountAlwaysOnTop", TRUE);

	if (GetRCBool("LSCountNoDisplay", FALSE))
	{
		hwndMain = CreateWindow("LSCount", "LSCount", WS_VISIBLE | WS_POPUP, X, Y, W, H, parent, NULL, dll, 0);
		if (AOT) SetWindowPos(hwndMain, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
		SetWindowLong(hwndMain, GWL_USERDATA, magicDWord);
	}

	return 1;
}

int quitModule(HINSTANCE dll)
{
	DestroyWindow(hwndMain);
	DestroyWindow(hwndDlg);
	DeleteObject(Font);
	TerminateThread(thread, 0);
	return 0;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_NCHITTEST: return HTCAPTION;

		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd, &ps);
			char temp[100] = "";
			
			PaintDesktop(hdc);
			if (ID == -1)
				sprintf(temp, "%s?", PreText);
			else
				sprintf(temp, "%s%d", PreText, ID);

			SetBkMode(hdc, TRANSPARENT);
			SetTextColor(hdc, FontColor);
			SelectObject(hdc, Font);
			TextOut(hdc, 1, 1, temp, strlen(temp));

			EndPaint(hwnd, &ps);
		}
		break;

		case WM_WINDOWPOSCHANGING: 
		{
			WINDOWPOS* pos = (WINDOWPOS*)lParam;
			
			if (AOT) pos->hwndInsertAfter = HWND_TOPMOST;
			else pos->hwndInsertAfter = HWND_BOTTOM;

			if (!(pos->flags & SWP_NOMOVE))
			{
				if (pos->x+W >= ScreenX-5) pos->x = ScreenX - W;
				else if (pos->x <= 5) pos->x = 0;
				if (pos->y+H >= ScreenY-5) pos->y = ScreenY - H;
				else if (pos->y <= 5) pos->y = 0;
			}

			InvalidateRect(hwnd, NULL, TRUE); break;
		}
	}

	return DefWindowProc(hwnd, msg, wParam, lParam);
}

BOOL CALLBACK DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_COMMAND:
		{
			switch (HIWORD(wParam))
			{
				case BN_CLICKED:
				{
					if (LOWORD(wParam) == IDC_EXIT)
					{
						EndDialog(hwnd, -1);
					}
				}
				break;
			}
		}
		break;
	}
	return FALSE;
}

int CheckForMark()
{
	// Check for the mark and return the ID
	return 1;
}

BOOL Register()
{
	int numbytes;
	char buf[100];
	struct hostent *he;
	struct sockaddr_in their_addr;
	char hostname[256] = "";
	WSADATA wsaData;
	SOCKET sockfd;
	
	SetWindowText(status, "Starting Windows Sockets...");
	Sleep(500);
	if (WSAStartup(0x202,&wsaData) == SOCKET_ERROR)
	{
		WSACleanup();
		SetWindowText(status, "Starting Windows Sockets...error.");
		ShowWindow(exitbtn, SW_SHOW);
		return FALSE;
	}
	SetWindowText(status, "Starting Windows Sockets...done.");
	Sleep(500);

	SetWindowText(status, "Resolving hostname...");
	Sleep(500);
	if ((he=gethostbyname(SERVER)) == NULL) 
	{	
		//perror("gethostbyname");
		WSACleanup();
		SetWindowText(status, "Resolving hostname...error.");
		ShowWindow(exitbtn, SW_SHOW);
		return FALSE;
	}
	SetWindowText(status, "Resolving hostname...done.");
	Sleep(500);

	SetWindowText(status, "Connecting socket...");
	Sleep(500);
	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) 
	{
		//perror("socket");
		WSACleanup();
		SetWindowText(status, "Connecting socket...error.");
		ShowWindow(exitbtn, SW_SHOW);
		return FALSE;
	}
	SetWindowText(status, "Connecting socket...done.");
	Sleep(500);

	their_addr.sin_family = AF_INET;
	their_addr.sin_port = htons(PORT);
	their_addr.sin_addr = *((struct in_addr *)he->h_addr);
	memset(&(their_addr.sin_zero), 0, 8);

	SetWindowText(status, "Connecting to host...");
	Sleep(500);
	if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) == -1) 
	{
		//perror("connect");
		WSACleanup();
		SetWindowText(status, "Connecting to host...error.");
		ShowWindow(exitbtn, SW_SHOW);
		return FALSE;
	}
	SetWindowText(status, "Connecting to host...connected.");
	Sleep(500);

	if ((numbytes=recv(sockfd, buf, 100, 0)) == -1)
    {
        WSACleanup();
		SetWindowText(status, "Error receiving data...");
		ShowWindow(exitbtn, SW_SHOW);
		return FALSE;
    }
    buf[numbytes] = '\0';

	SetWindowText(status, "Verifying...");
	Sleep(500);
    if (!strcmp(buf, "Enter Password: "))
    {
      if (send(sockfd, "********", 16, 0) == -1) 
	  {
		  	WSACleanup();
			SetWindowText(status, "Error sending data...");
			ShowWindow(exitbtn, SW_SHOW);
			return FALSE;
	  }

      if ((numbytes=recv(sockfd, buf, 100, 0)) == -1)
      {
			WSACleanup();
			SetWindowText(status, "Error receiving data...");
			ShowWindow(exitbtn, SW_SHOW);
			return FALSE;
      }
      buf[numbytes] = '\0';

	  if (!strncmp(buf, "OK", 2))
	  {
		  ID = atoi(buf+3);
	  }
	  else
	  {
		  ID=-1;
		  SetWindowText(status, "Verifying...failed.");
		  Sleep(500);
	  }
    }

	SetWindowText(status, "Disconnecting...");
	Sleep(500);
	closesocket(sockfd);
	SetWindowText(status, "Disconnecting...disconnected.");
	if (ID >= 0) 
	{
		SetMark();
		Sleep(500);
		sprintf(buf, "Thank you for your support!\r\nYou are LiteSTEP User #%d.", ID);
		SetWindowText(status, buf);
	}
	else SetWindowText(status, "An error occurred.");
	
	InvalidateRect(hwndMain, NULL, TRUE);
	ShowWindow(exitbtn, SW_SHOW);
	return TRUE;
}

BOOL SetMark()
{
	// Set the mark and ID
	return TRUE;
}